"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.execCommand = void 0;
const node_child_process_1 = require("node:child_process");
async function execCommand(cmd, args, options) {
    return new Promise((resolve, reject) => {
        const child = (0, node_child_process_1.spawn)(cmd, args, {
            ...options,
            stdio: ['pipe', 'pipe', 'pipe'],
            encoding: 'utf-8',
        });
        let stdout = '';
        child.stdout.on('data', (chunk) => {
            stdout += chunk;
        });
        child.on('error', (error) => {
            reject(error);
        });
        child.on('close', (code) => {
            if (code !== 0) {
                reject(new Error(`Command failed with exit code ${code}`));
            }
            else {
                resolve(stdout);
            }
        });
    });
}
exports.execCommand = execCommand;
